install.sh 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. IS_WSL2=false
  29. KERN=$(uname -r)
  30. case "$KERN" in
  31. *icrosoft*WSL2 | *icrosoft*wsl2) IS_WSL2=true;;
  32. *icrosoft) error "Microsoft WSL1 is not currently supported. Please upgrade to WSL2 with 'wsl --set-version <distro> 2'" ;;
  33. *) ;;
  34. esac
  35. VER_PARAM="${OLLAMA_VERSION:+?version=$OLLAMA_VERSION}"
  36. SUDO=
  37. if [ "$(id -u)" -ne 0 ]; then
  38. # Running as root, no need for sudo
  39. if ! available sudo; then
  40. error "This script requires superuser permissions. Please re-run as root."
  41. fi
  42. SUDO="sudo"
  43. fi
  44. NEEDS=$(require curl awk grep sed tee xargs)
  45. if [ -n "$NEEDS" ]; then
  46. status "ERROR: The following tools are required but missing:"
  47. for NEED in $NEEDS; do
  48. echo " - $NEED"
  49. done
  50. exit 1
  51. fi
  52. for BINDIR in /usr/local/bin /usr/bin /bin; do
  53. echo $PATH | grep -q $BINDIR && break || continue
  54. done
  55. OLLAMA_INSTALL_DIR=${OLLAMA_INSTALL_DIR:-${BINDIR}}
  56. status "Installing ollama to $OLLAMA_INSTALL_DIR"
  57. $SUDO install -o0 -g0 -m755 -d $BINDIR
  58. $SUDO install -o0 -g0 -m755 -d "$OLLAMA_INSTALL_DIR"
  59. if curl -I --silent --fail --location "https://ollama.com/download/ollama-linux-${ARCH}.tgz${VER_PARAM}" >/dev/null ; then
  60. status "Downloading Linux ${ARCH} bundle"
  61. curl --fail --show-error --location --progress-bar \
  62. "https://ollama.com/download/ollama-linux-${ARCH}.tgz${VER_PARAM}" | \
  63. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  64. BUNDLE=1
  65. else
  66. status "Downloading Linux ${ARCH} CLI"
  67. curl --fail --show-error --location --progress-bar -o "$TEMP_DIR/ollama"\
  68. "https://ollama.com/download/ollama-linux-${ARCH}${VER_PARAM}"
  69. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $OLLAMA_INSTALL_DIR/ollama
  70. BUNDLE=0
  71. fi
  72. if [ "$OLLAMA_INSTALL_DIR/ollama" != "$BINDIR/ollama" ] ; then
  73. status "Making ollama accessible in the PATH in $BINDIR"
  74. $SUDO ln -sf "$OLLAMA_INSTALL_DIR/ollama" "$BINDIR/ollama"
  75. fi
  76. install_success() {
  77. status 'The Ollama API is now available at 127.0.0.1:11434.'
  78. status 'Install complete. Run "ollama" from the command line.'
  79. }
  80. trap install_success EXIT
  81. # Everything from this point onwards is optional.
  82. configure_systemd() {
  83. if ! id ollama >/dev/null 2>&1; then
  84. status "Creating ollama user..."
  85. $SUDO useradd -r -s /bin/false -U -m -d /usr/share/ollama ollama
  86. fi
  87. if getent group render >/dev/null 2>&1; then
  88. status "Adding ollama user to render group..."
  89. $SUDO usermod -a -G render ollama
  90. fi
  91. if getent group video >/dev/null 2>&1; then
  92. status "Adding ollama user to video group..."
  93. $SUDO usermod -a -G video ollama
  94. fi
  95. status "Adding current user to ollama group..."
  96. $SUDO usermod -a -G ollama $(whoami)
  97. status "Creating ollama systemd service..."
  98. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  99. [Unit]
  100. Description=Ollama Service
  101. After=network-online.target
  102. [Service]
  103. ExecStart=$BINDIR/ollama serve
  104. User=ollama
  105. Group=ollama
  106. Restart=always
  107. RestartSec=3
  108. Environment="PATH=$PATH"
  109. [Install]
  110. WantedBy=default.target
  111. EOF
  112. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  113. case $SYSTEMCTL_RUNNING in
  114. running|degraded)
  115. status "Enabling and starting ollama service..."
  116. $SUDO systemctl daemon-reload
  117. $SUDO systemctl enable ollama
  118. start_service() { $SUDO systemctl restart ollama; }
  119. trap start_service EXIT
  120. ;;
  121. esac
  122. }
  123. if available systemctl; then
  124. configure_systemd
  125. fi
  126. # WSL2 only supports GPUs via nvidia passthrough
  127. # so check for nvidia-smi to determine if GPU is available
  128. if [ "$IS_WSL2" = true ]; then
  129. if available nvidia-smi && [ -n "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  130. status "Nvidia GPU detected."
  131. fi
  132. install_success
  133. exit 0
  134. fi
  135. # Install GPU dependencies on Linux
  136. if ! available lspci && ! available lshw; then
  137. warning "Unable to detect NVIDIA/AMD GPU. Install lspci or lshw to automatically detect and install GPU dependencies."
  138. exit 0
  139. fi
  140. check_gpu() {
  141. # Look for devices based on vendor ID for NVIDIA and AMD
  142. case $1 in
  143. lspci)
  144. case $2 in
  145. nvidia) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  146. amdgpu) available lspci && lspci -d '1002:' | grep -q 'AMD' || return 1 ;;
  147. esac ;;
  148. lshw)
  149. case $2 in
  150. nvidia) available lshw && $SUDO lshw -c display -numeric -disable network | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  151. amdgpu) available lshw && $SUDO lshw -c display -numeric -disable network | grep -q 'vendor: .* \[1002\]' || return 1 ;;
  152. esac ;;
  153. nvidia-smi) available nvidia-smi || return 1 ;;
  154. esac
  155. }
  156. if check_gpu nvidia-smi; then
  157. status "NVIDIA GPU installed."
  158. exit 0
  159. fi
  160. if ! check_gpu lspci nvidia && ! check_gpu lshw nvidia && ! check_gpu lspci amdgpu && ! check_gpu lshw amdgpu; then
  161. install_success
  162. warning "No NVIDIA/AMD GPU detected. Ollama will run in CPU-only mode."
  163. exit 0
  164. fi
  165. if check_gpu lspci amdgpu || check_gpu lshw amdgpu; then
  166. if [ $BUNDLE -ne 0 ]; then
  167. install_success
  168. status "AMD GPU ready."
  169. exit 0
  170. fi
  171. # Look for pre-existing ROCm v6 before downloading the dependencies
  172. for search in "${HIP_PATH:-''}" "${ROCM_PATH:-''}" "/opt/rocm" "/usr/lib64"; do
  173. if [ -n "${search}" ] && [ -e "${search}/libhipblas.so.2" -o -e "${search}/lib/libhipblas.so.2" ]; then
  174. status "Compatible AMD GPU ROCm library detected at ${search}"
  175. install_success
  176. exit 0
  177. fi
  178. done
  179. status "Downloading AMD GPU dependencies..."
  180. $SUDO rm -rf /usr/share/ollama/lib
  181. $SUDO chmod o+x /usr/share/ollama
  182. $SUDO install -o ollama -g ollama -m 755 -d /usr/share/ollama/lib/rocm
  183. curl --fail --show-error --location --progress-bar "https://ollama.com/download/ollama-linux-amd64-rocm.tgz${VER_PARAM}" \
  184. | $SUDO tar zx --owner ollama --group ollama -C /usr/share/ollama/lib/rocm .
  185. install_success
  186. status "AMD GPU ready."
  187. exit 0
  188. fi
  189. CUDA_REPO_ERR_MSG="NVIDIA GPU detected, but your OS and Architecture are not supported by NVIDIA. Please install the CUDA driver manually https://docs.nvidia.com/cuda/cuda-installation-guide-linux/"
  190. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  191. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  192. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  193. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  194. install_cuda_driver_yum() {
  195. status 'Installing NVIDIA repository...'
  196. case $PACKAGE_MANAGER in
  197. yum)
  198. $SUDO $PACKAGE_MANAGER -y install yum-utils
  199. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo" >/dev/null ; then
  200. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo
  201. else
  202. error $CUDA_REPO_ERR_MSG
  203. fi
  204. ;;
  205. dnf)
  206. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo" >/dev/null ; then
  207. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo
  208. else
  209. error $CUDA_REPO_ERR_MSG
  210. fi
  211. ;;
  212. esac
  213. case $1 in
  214. rhel)
  215. status 'Installing EPEL repository...'
  216. # EPEL is required for third-party dependencies such as dkms and libvdpau
  217. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  218. ;;
  219. esac
  220. status 'Installing CUDA driver...'
  221. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  222. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  223. fi
  224. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  225. }
  226. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  227. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  228. install_cuda_driver_apt() {
  229. status 'Installing NVIDIA repository...'
  230. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-keyring_1.1-1_all.deb" >/dev/null ; then
  231. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-keyring_1.1-1_all.deb
  232. else
  233. error $CUDA_REPO_ERR_MSG
  234. fi
  235. case $1 in
  236. debian)
  237. status 'Enabling contrib sources...'
  238. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  239. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  240. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  241. fi
  242. ;;
  243. esac
  244. status 'Installing CUDA driver...'
  245. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  246. $SUDO apt-get update
  247. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  248. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  249. }
  250. if [ ! -f "/etc/os-release" ]; then
  251. error "Unknown distribution. Skipping CUDA installation."
  252. fi
  253. . /etc/os-release
  254. OS_NAME=$ID
  255. OS_VERSION=$VERSION_ID
  256. PACKAGE_MANAGER=
  257. for PACKAGE_MANAGER in dnf yum apt-get; do
  258. if available $PACKAGE_MANAGER; then
  259. break
  260. fi
  261. done
  262. if [ -z "$PACKAGE_MANAGER" ]; then
  263. error "Unknown package manager. Skipping CUDA installation."
  264. fi
  265. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  266. case $OS_NAME in
  267. centos|rhel) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -d '.' -f 1) ;;
  268. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  269. fedora) [ $OS_VERSION -lt '39' ] && install_cuda_driver_yum $OS_NAME $OS_VERSION || install_cuda_driver_yum $OS_NAME '39';;
  270. amzn) install_cuda_driver_yum 'fedora' '37' ;;
  271. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  272. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  273. *) exit ;;
  274. esac
  275. fi
  276. if ! lsmod | grep -q nvidia || ! lsmod | grep -q nvidia_uvm; then
  277. KERNEL_RELEASE="$(uname -r)"
  278. case $OS_NAME in
  279. rocky) $SUDO $PACKAGE_MANAGER -y install kernel-devel kernel-headers ;;
  280. centos|rhel|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  281. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  282. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  283. *) exit ;;
  284. esac
  285. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  286. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  287. $SUDO dkms install $NVIDIA_CUDA_VERSION
  288. fi
  289. if lsmod | grep -q nouveau; then
  290. status 'Reboot to complete NVIDIA CUDA driver install.'
  291. exit 0
  292. fi
  293. $SUDO modprobe nvidia
  294. $SUDO modprobe nvidia_uvm
  295. fi
  296. # make sure the NVIDIA modules are loaded on boot with nvidia-persistenced
  297. if command -v nvidia-persistenced > /dev/null 2>&1; then
  298. $SUDO touch /etc/modules-load.d/nvidia.conf
  299. MODULES="nvidia nvidia-uvm"
  300. for MODULE in $MODULES; do
  301. if ! grep -qxF "$MODULE" /etc/modules-load.d/nvidia.conf; then
  302. echo "$MODULE" | sudo tee -a /etc/modules-load.d/nvidia.conf > /dev/null
  303. fi
  304. done
  305. fi
  306. status "NVIDIA GPU ready."
  307. install_success